VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Sierpinski2"
   ClientHeight    =   4650
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5640
   LinkTopic       =   "Form1"
   ScaleHeight     =   4650
   ScaleWidth      =   5640
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Left-click at least two points. Then right-click to begin. Click again to stop"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Running As Boolean
Private m_NumPoints As Integer
Private m_CornerX() As Single
Private m_CornerY() As Single

Private Const RADIUS As Single = 60
Private Sub PlotPoints()
Dim i As Integer
Dim last_x As Single
Dim last_y As Single

    ' Pick a starting point.
    i = Int(Rnd * m_NumPoints)
    last_x = m_CornerX(i)
    last_y = m_CornerY(i)

    ' Plot points until the user clicks again.
    Do While m_Running
        ' Pick the next corner.
        i = Int(Rnd * m_NumPoints)

        ' Move halfway from the current point
        ' to the new corner.
        last_x = (last_x + m_CornerX(i)) / 2
        last_y = (last_y + m_CornerY(i)) / 2
        Me.PSet (last_x, last_y)

        ' Check for events.
        DoEvents
    Loop
End Sub

Private Sub Form_Load()
    Randomize
End Sub


Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If m_Running Then
        ' Stop running.
        m_Running = False
        m_NumPoints = 0
    Else
        ' Left or right button?
        If Button = vbLeftButton Then
            ' If this is the first point,
            ' erase the previous picture.
            If m_NumPoints = 0 Then Me.Cls

            ' Save the point.
            m_NumPoints = m_NumPoints + 1
            ReDim Preserve m_CornerX(0 To m_NumPoints - 1)
            ReDim Preserve m_CornerY(0 To m_NumPoints - 1)
            m_CornerX(m_NumPoints - 1) = X
            m_CornerY(m_NumPoints - 1) = Y
            Me.Circle (X, Y), RADIUS
        Else
            ' See if we have enough points.
            If m_NumPoints < 2 Then
                ' We need more points.
                MsgBox "You must left-click at least two points before right-clicking.", _
                    vbExclamation, "Need More Points"
            Else
                ' Start.
                m_Running = True
                PlotPoints
            End If
        End If
    End If
End Sub

Private Sub Form_Resize()
Dim wid As Single

    wid = Me.ScaleWidth - 2 * Label1.Left
    If wid < 120 Then wid = 120
    Label1.Width = wid
End Sub


Private Sub Form_Unload(Cancel As Integer)
    End
End Sub


